/***************************************************************************/
/*                                                                         */
/* TnWator Copyright (c) 2008 The_Nihilant                                 */
/* Any unauthorized use of this program is forbidden.                      */
/* This program is released under the GNU GPL v.3 or later.                */
/*                                                                         */
/***************************************************************************/

#include <wx/wx.h>
#include <wx/rawbmp.h>

#include <unistd.h>              
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>           /* For O_* constants */

#include "wator_shm.h"
#define WORD sizeof(int) // ugly? retrocompatibility with tnemu!

class tnguiApp : public wxApp { public: virtual bool OnInit(); };
enum
{
  Timer1 = 100,
  Pannello
};

int colori[3] = {0x7f0000,0x007F00,0x007fff};

wxBitmap bm;
unsigned char*mymem;
int fd;
int keybfd;
int mousefd;
int*video_mem;

int ppx;
int ppy;

int mouse_x=0;
int mouse_y=0;




class tnguiPanel : public wxPanel
{
  public:
    tnguiPanel(wxWindow* parent, wxWindowID id = wxID_ANY);
    void OnPaint(wxPaintEvent& event);

  DECLARE_EVENT_TABLE();
};

BEGIN_EVENT_TABLE(tnguiPanel,wxPanel)
  EVT_PAINT(tnguiPanel::OnPaint)
END_EVENT_TABLE()


class tnguiFrame : public wxFrame
{
  public:
    tnguiFrame( const wxString& title, const wxPoint& pos, const wxSize& pos );
    void OnTimer(wxTimerEvent& event);
  private:
    wxTimer timer;
    wxPanel* thepanel;
    void reload_image();
    
    DECLARE_EVENT_TABLE();
};



void tnguiFrame::reload_image(){
  wxImage im;
  int rx,ry;
  
  if(!video_mem){
   fprintf(stderr,"trying to initialize video in.\n");
   fd=shm_open(WATOR_SHM,O_RDONLY,0);
   if(fd==-1)return;
   read(fd,&rx,WORD);
   read(fd,&ry,WORD);
   video_mem=(int*)mmap(NULL,(rx*ry+2)*WORD,PROT_READ,MAP_SHARED,fd,0);
   if(video_mem==MAP_FAILED){video_mem=NULL;return;}
   ppx=rx;
   ppy=ry;
   //SetSize(ppx,ppy);
   fprintf(stderr,"resolution: %dx%d.\n",ppx,ppy);
   mymem=(unsigned char*)malloc(ppx*ppy*3);
  }

  int*vm=(video_mem+2);

  unsigned char*mm=mymem;
  /* HORRRBILE HACK!  DEPENDS ON BEING ON A LITTLE ENDIAN SYSTEM! */
  for(int cx=0;cx<ppx*ppy;cx++){ 
   *((int*)mm)=colori[*vm];
   mm+=3;
   vm++;
  }
  
  int qx,qy;
  GetSize(&qx,&qy);
  qx-=2;qy-=2;
  im=wxImage(ppx,ppy,mymem,TRUE);
  if((qx>ppx)&&(qy>ppy)) im.Rescale(qx,qy);
  bm=wxBitmap(im);            
}


BEGIN_EVENT_TABLE(tnguiFrame,wxFrame)
    EVT_TIMER(Timer1,tnguiFrame::OnTimer)
END_EVENT_TABLE()

IMPLEMENT_APP(tnguiApp)
 

bool tnguiApp::OnInit()
{
  tnguiFrame*frame=new tnguiFrame(wxT("wator_display!  by The_Nihilant 2008  ~  released under GPLv3 or later."),
                                  wxPoint(50,50),wxSize(642,482));
  frame->Show(TRUE);
  SetTopWindow(frame);

  fd=-1;
  video_mem=NULL;  

  return TRUE;
} 

tnguiFrame::tnguiFrame(const wxString&title,const wxPoint&pos,const wxSize&size)
  :wxFrame((wxFrame *)NULL, -1, title, pos, size,wxDEFAULT_FRAME_STYLE)
{ 
  thepanel=new tnguiPanel(this,Pannello);
  thepanel->SetFocus();

  reload_image();     
  SetSize(2*ppx+2,2*ppy+2);

  timer.SetOwner(this,Timer1); 
  timer.Start(40);
}

void tnguiFrame::OnTimer(wxTimerEvent& WXUNUSED(event)){
 reload_image();
 Refresh();
}




/*
static char curs_bits[] = {0};
static char curs_mask[] = {0};
*/

tnguiPanel::tnguiPanel(wxWindow* parent, wxWindowID id)
   :wxPanel(parent,id)
{
/*
#ifdef __WXMSW__
  wxBitmap down_bitmap(curs_bits, 2, 2);
  wxBitmap down_mask_bitmap(curs_mask, 2, 2);

  down_bitmap.SetMask(new wxMask(down_mask_bitmap));
  wxImage down_image = down_bitmap.ConvertToImage();
  down_image.SetOption(wxIMAGE_OPTION_CUR_HOTSPOT_X, 0);
  down_image.SetOption(wxIMAGE_OPTION_CUR_HOTSPOT_Y, 0);
  wxCursor curs = wxCursor(down_image);
#else
  wxCursor curs = wxCursor(curs_bits, 2, 2, 0, 0, curs_mask, wxWHITE, wxBLACK);
#endif
  SetCursor(curs);
  */
}



void tnguiPanel::OnPaint(wxPaintEvent& WXUNUSED(event)) {
 wxPaintDC dc(this);
 dc.DrawBitmap(bm,0,0);
}

